Index: config/platforms/tyan-s2891.conf
===================================================================
--- config/platforms/tyan-s2891.conf	(revision 153)
+++ config/platforms/tyan-s2891.conf	(working copy)
@@ -41,7 +41,7 @@
 CBV2_CONFIG=Config.lb
 CBV2_PAYLOAD_FILE_EXT=elf
 CBV2_TDIR=s2891
-CBV2_TAG=3164
+CBV2_TAG=3258
 
 # FILO configuration
 
Index: config/platforms/tyan-s2892.conf
===================================================================
--- config/platforms/tyan-s2892.conf	(revision 144)
+++ config/platforms/tyan-s2892.conf	(working copy)
@@ -1,4 +1,4 @@
-# Support for the Tyan S2891 board
+# Support for the Tyan S2892 board
 
 #### Platform configuration
 
@@ -16,34 +16,32 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/tyan-s2891.mk
-CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/tyan-s2891.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/tiny-2.6.22.mk
+CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/tyan-generic.mk
 
 # kernel configuration (for LAB)
 
 KERNEL_VERSION=2.6.22.2
 
 ifeq ($(CONFIG_TARGET_64BIT),y)
-$(error You must specify a kernel configuration for 64 bit)
+KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-tiny-2.6.22-x86_64
 else
-KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-tyan-s2891
+KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-tiny-2.6.22
 endif
 
-#UCLIBC_ARCH=i386
-
 # Etherboot configuration
 ETHERBOOT_ARCH=i386
 
 # coreboot configuration
 
 COREBOOT_VENDOR=tyan
-COREBOOT_BOARD=s2891
+COREBOOT_BOARD=s2892
 CBV2_CONFIG=Config.lb
 CBV2_PAYLOAD_FILE_EXT=elf
-CBV2_TDIR=s2891
-CBV2_TAG=3164
+CBV2_TDIR=s2892
+CBV2_TAG=3258
 
 # FILO configuration
 
-FILO_CONFIG=tyan-s2891-Config
+FILO_CONFIG=tyan-generic-Config
 
Index: config/platforms/tyan-s2895.conf
===================================================================
--- config/platforms/tyan-s2895.conf	(revision 144)
+++ config/platforms/tyan-s2895.conf	(working copy)
@@ -1,4 +1,4 @@
-# Support for the Tyan S2891 board
+# Support for the Tyan S2895 board
 
 #### Platform configuration
 
@@ -16,34 +16,32 @@
 
 # Targets
 
-KERNEL_MK=$(PACKAGE_DIR)/kernel/tyan-s2891.mk
-CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/tyan-s2891.mk
+KERNEL_MK=$(PACKAGE_DIR)/kernel/tiny-2.6.22.mk
+CBV2_MK=$(PACKAGE_DIR)/coreboot-v2/tyan-generic.mk
 
 # kernel configuration (for LAB)
 
 KERNEL_VERSION=2.6.22.2
 
 ifeq ($(CONFIG_TARGET_64BIT),y)
-$(error You must specify a kernel configuration for 64 bit)
+KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-tiny-2.6.22-x86_64
 else
-KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-tyan-s2891
+KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-tiny-2.6.22
 endif
 
-#UCLIBC_ARCH=i386
-
 # Etherboot configuration
 ETHERBOOT_ARCH=i386
 
 # coreboot configuration
 
 COREBOOT_VENDOR=tyan
-COREBOOT_BOARD=s2891
+COREBOOT_BOARD=s2895
 CBV2_CONFIG=Config.lb
 CBV2_PAYLOAD_FILE_EXT=elf
-CBV2_TDIR=s2891
-CBV2_TAG=3164
+CBV2_TDIR=s2895
+CBV2_TAG=3258
 
 # FILO configuration
 
-FILO_CONFIG=tyan-s2891-Config
+FILO_CONFIG=tyan-generic-Config
 
Index: config/platforms/platforms.conf
===================================================================
--- config/platforms/platforms.conf	(revision 153)
+++ config/platforms/platforms.conf	(working copy)
@@ -17,6 +17,8 @@
 PLATFORM-$(CONFIG_PLATFORM_TYAN_S2881) = tyan-s2881.conf
 PLATFORM-$(CONFIG_PLATFORM_TYAN_S2882) = tyan-s2882.conf
 PLATFORM-$(CONFIG_PLATFORM_TYAN_S2891) = tyan-s2891.conf
+PLATFORM-$(CONFIG_PLATFORM_TYAN_S2892) = tyan-s2892.conf
+PLATFORM-$(CONFIG_PLATFORM_TYAN_S2895) = tyan-s2895.conf
 PLATFORM-$(CONFIG_PLATFORM_SUPERMICRO_H8DMR) = supermicro-h8dmr.conf
 PLATFORM-$(CONFIG_PLATFORM_SERENGETI_CHEETAH) = serengeti_cheetah.conf
 PLATFORM-$(CONFIG_PLATFORM_CHEETAH_FAM10) = serengeti_cheetah.conf
Index: config/platforms/Config.in
===================================================================
--- config/platforms/Config.in	(revision 153)
+++ config/platforms/Config.in	(working copy)
@@ -125,6 +125,20 @@
        select PLATFORM
        select PLATFORM_SUPPORT_64BIT
 
+config PLATFORM_TYAN_S2892
+       bool "Tyan S2892"
+       depends on VENDOR_TYAN
+       depends on COREBOOT_V2
+       select PLATFORM
+       select PLATFORM_SUPPORT_64BIT
+
+config PLATFORM_TYAN_S2895
+       bool "Tyan S2895"
+       depends on VENDOR_TYAN
+       depends on COREBOOT_V2
+       select PLATFORM
+       select PLATFORM_SUPPORT_64BIT
+
 config PLATFORM_QEMU-X86
        bool "QEMU Emulator"
        depends on VENDOR_QEMU
Index: packages/kernel/conf/defconfig-tiny-2.6.22-x86_64
===================================================================
--- packages/kernel/conf/defconfig-tiny-2.6.22-x86_64	(revision 144)
+++ packages/kernel/conf/defconfig-tiny-2.6.22-x86_64	(working copy)
@@ -1,7 +1,7 @@
 #
 # Automatically generated make config: don't edit
 # Linux kernel version: 2.6.22.2
-# Wed Oct 31 08:59:35 2007
+# Wed Apr 23 09:24:45 2008
 #
 CONFIG_X86_64=y
 CONFIG_64BIT=y
@@ -39,60 +39,62 @@
 #
 # General setup
 #
-CONFIG_LOCALVERSION="tiny"
+CONFIG_LOCALVERSION="BuildROM L-A-B V1.0"
 # CONFIG_LOCALVERSION_AUTO is not set
 # CONFIG_SWAP is not set
 # CONFIG_SYSVIPC is not set
 # CONFIG_BSD_PROCESS_ACCT is not set
 # CONFIG_UTS_NS is not set
 # CONFIG_IKCONFIG is not set
-CONFIG_LOG_BUF_SHIFT=15
+CONFIG_LOG_BUF_SHIFT=17
 # CONFIG_CPUSETS is not set
 # CONFIG_SYSFS_DEPRECATED is not set
 # CONFIG_RELAY is not set
 CONFIG_BLK_DEV_INITRD=y
 CONFIG_INITRAMFS_SOURCE=""
-CONFIG_SYSENTER=y
+# CONFIG_SYSENTER is not set
 # CONFIG_AIO is not set
 # CONFIG_XATTR is not set
 # CONFIG_FILE_LOCKING is not set
 # CONFIG_INETPEER is not set
 # CONFIG_MEASURE_INLINES is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
+CONFIG_SYSCTL=y
 CONFIG_EMBEDDED=y
 # CONFIG_UID16 is not set
 # CONFIG_SYSCTL_SYSCALL is not set
 # CONFIG_KALLSYMS is not set
-# CONFIG_HOTPLUG is not set
+CONFIG_HOTPLUG=y
 CONFIG_PRINTK_FUNC=y
 CONFIG_PRINTK=y
 # CONFIG_BUG is not set
-# CONFIG_ELF_CORE is not set
+CONFIG_ELF_CORE=y
 CONFIG_PANIC=y
-# CONFIG_FULL_PANIC is not set
-# CONFIG_BASE_FULL is not set
+CONFIG_FULL_PANIC=y
+CONFIG_BASE_FULL=y
 CONFIG_NET_SMALL=y
-# CONFIG_FUTEX is not set
+CONFIG_FUTEX=y
 CONFIG_ANON_INODES=y
-# CONFIG_EPOLL is not set
+CONFIG_EPOLL=y
 CONFIG_SIGNALFD=y
 CONFIG_TIMERFD=y
 CONFIG_EVENTFD=y
-# CONFIG_SHMEM is not set
+CONFIG_SHMEM=y
 # CONFIG_CRC32_TABLES is not set
-CONFIG_VM_EVENT_COUNTERS=y
+# CONFIG_VM_EVENT_COUNTERS is not set
 CONFIG_SLAB=y
 # CONFIG_SLUB is not set
 # CONFIG_SLOB is not set
-# CONFIG_CC_FUNIT_AT_A_TIME is not set
-# CONFIG_LINUXTINY_DO_UNINLINE is not set
+CONFIG_CC_FUNIT_AT_A_TIME=y
+CONFIG_LINUXTINY_DO_UNINLINE=y
 CONFIG_BINFMT_SCRIPT=y
-CONFIG_MAX_SWAPFILES_SHIFT=5
-CONFIG_NR_LDISCS=16
-CONFIG_MAX_USER_RT_PRIO=100
+CONFIG_MAX_SWAPFILES_SHIFT=0
+CONFIG_NR_LDISCS=2
+CONFIG_MAX_USER_RT_PRIO=5
+CONFIG_RT_MUTEXES=y
 CONFIG_CRC32_CALC=y
-CONFIG_TINY_SHMEM=y
-CONFIG_BASE_SMALL=1
+# CONFIG_TINY_SHMEM is not set
+CONFIG_BASE_SMALL=0
 
 #
 # Loadable module support
@@ -103,19 +105,20 @@
 # Block layer
 #
 CONFIG_BLOCK=y
+# CONFIG_BLK_DEV_IO_TRACE is not set
 
 #
 # IO Schedulers
 #
 CONFIG_IOSCHED_NOOP=y
-# CONFIG_IOSCHED_AS is not set
+CONFIG_IOSCHED_AS=y
 # CONFIG_IOSCHED_DEADLINE is not set
 # CONFIG_IOSCHED_CFQ is not set
-# CONFIG_DEFAULT_AS is not set
+CONFIG_DEFAULT_AS=y
 # CONFIG_DEFAULT_DEADLINE is not set
 # CONFIG_DEFAULT_CFQ is not set
-CONFIG_DEFAULT_NOOP=y
-CONFIG_DEFAULT_IOSCHED="noop"
+# CONFIG_DEFAULT_NOOP is not set
+CONFIG_DEFAULT_IOSCHED="anticipatory"
 
 #
 # Processor type and features
@@ -155,10 +158,12 @@
 CONFIG_HAVE_MEMORY_PRESENT=y
 # CONFIG_SPARSEMEM_STATIC is not set
 CONFIG_SPARSEMEM_EXTREME=y
+# CONFIG_MEMORY_HOTPLUG is not set
 CONFIG_SPLIT_PTLOCK_CPUS=4
 CONFIG_RESOURCES_64BIT=y
 CONFIG_ZONE_DMA_FLAG=1
 CONFIG_NR_CPUS=2
+# CONFIG_HOTPLUG_CPU is not set
 CONFIG_ARCH_ENABLE_MEMORY_HOTPLUG=y
 CONFIG_HPET_TIMER=y
 CONFIG_IOMMU=y
@@ -188,6 +193,7 @@
 CONFIG_PM=y
 # CONFIG_PM_LEGACY is not set
 # CONFIG_PM_DEBUG is not set
+# CONFIG_PM_SYSFS_DEPRECATED is not set
 
 #
 # ACPI (Advanced Configuration and Power Interface) Support
@@ -233,6 +239,8 @@
 #
 # PCCARD (PCMCIA/CardBus) support
 #
+# CONFIG_PCCARD is not set
+# CONFIG_HOTPLUG_PCI is not set
 
 #
 # Executable file formats / Emulations
@@ -257,6 +265,7 @@
 #
 # CONFIG_STANDALONE is not set
 CONFIG_PREVENT_FIRMWARE_BUILD=y
+# CONFIG_FW_LOADER is not set
 # CONFIG_SYS_HYPERVISOR is not set
 
 #
@@ -546,9 +555,57 @@
 # CONFIG_TCG_TPM is not set
 # CONFIG_TELCLOCK is not set
 CONFIG_DEVPORT=y
-# CONFIG_I2C is not set
+CONFIG_I2C=y
+CONFIG_I2C_BOARDINFO=y
+# CONFIG_I2C_CHARDEV is not set
 
 #
+# I2C Algorithms
+#
+CONFIG_I2C_ALGOBIT=y
+# CONFIG_I2C_ALGOPCF is not set
+CONFIG_I2C_ALGOPCA=y
+
+#
+# I2C Hardware Bus support
+#
+# CONFIG_I2C_ALI1535 is not set
+# CONFIG_I2C_ALI1563 is not set
+# CONFIG_I2C_ALI15X3 is not set
+# CONFIG_I2C_AMD756 is not set
+CONFIG_I2C_AMD8111=y
+# CONFIG_I2C_I801 is not set
+# CONFIG_I2C_I810 is not set
+# CONFIG_I2C_PIIX4 is not set
+CONFIG_I2C_NFORCE2=y
+# CONFIG_I2C_OCORES is not set
+# CONFIG_I2C_PARPORT_LIGHT is not set
+# CONFIG_I2C_PROSAVAGE is not set
+# CONFIG_I2C_SAVAGE4 is not set
+# CONFIG_I2C_SIMTEC is not set
+# CONFIG_I2C_SIS5595 is not set
+# CONFIG_I2C_SIS630 is not set
+# CONFIG_I2C_SIS96X is not set
+# CONFIG_I2C_VIA is not set
+# CONFIG_I2C_VIAPRO is not set
+# CONFIG_I2C_VOODOO3 is not set
+
+#
+# Miscellaneous I2C Chip support
+#
+# CONFIG_SENSORS_DS1337 is not set
+# CONFIG_SENSORS_DS1374 is not set
+# CONFIG_SENSORS_EEPROM is not set
+# CONFIG_SENSORS_PCF8574 is not set
+# CONFIG_SENSORS_PCA9539 is not set
+# CONFIG_SENSORS_PCF8591 is not set
+# CONFIG_SENSORS_MAX6875 is not set
+# CONFIG_I2C_DEBUG_CORE is not set
+# CONFIG_I2C_DEBUG_ALGO is not set
+# CONFIG_I2C_DEBUG_BUS is not set
+# CONFIG_I2C_DEBUG_CHIP is not set
+
+#
 # SPI support
 #
 # CONFIG_SPI is not set
@@ -676,8 +733,7 @@
 # File systems
 #
 CONFIG_EXT2_FS=y
-CONFIG_EXT2_FS_XIP=y
-CONFIG_FS_XIP=y
+# CONFIG_EXT2_FS_XIP is not set
 # CONFIG_EXT3_FS is not set
 # CONFIG_EXT4DEV_FS is not set
 # CONFIG_REISERFS_FS is not set
@@ -689,7 +745,7 @@
 # CONFIG_ROMFS_FS is not set
 # CONFIG_INOTIFY is not set
 # CONFIG_QUOTA is not set
-# CONFIG_DNOTIFY is not set
+CONFIG_DNOTIFY=y
 # CONFIG_AUTOFS_FS is not set
 # CONFIG_AUTOFS4_FS is not set
 # CONFIG_FUSE_FS is not set
@@ -697,27 +753,34 @@
 #
 # CD-ROM/DVD Filesystems
 #
-# CONFIG_ISO9660_FS is not set
+CONFIG_ISO9660_FS=y
+CONFIG_JOLIET=y
+# CONFIG_ZISOFS is not set
 # CONFIG_UDF_FS is not set
 
 #
 # DOS/FAT/NT Filesystems
 #
-# CONFIG_MSDOS_FS is not set
-# CONFIG_VFAT_FS is not set
+CONFIG_FAT_FS=y
+CONFIG_MSDOS_FS=y
+CONFIG_VFAT_FS=y
+CONFIG_FAT_DEFAULT_CODEPAGE=437
+CONFIG_FAT_DEFAULT_IOCHARSET="iso8859-1"
 # CONFIG_NTFS_FS is not set
 
 #
 # Pseudo filesystems
 #
 CONFIG_PROC_FS=y
-# CONFIG_PROC_KCORE is not set
-# CONFIG_PROC_SYSCTL is not set
-# CONFIG_SYSFS is not set
-# CONFIG_TMPFS is not set
+CONFIG_PROC_KCORE=y
+CONFIG_PROC_SYSCTL=y
+CONFIG_SYSFS=y
+CONFIG_TMPFS=y
+# CONFIG_TMPFS_POSIX_ACL is not set
 # CONFIG_HUGETLBFS is not set
 # CONFIG_HUGETLB_PAGE is not set
 CONFIG_RAMFS=y
+# CONFIG_CONFIGFS_FS is not set
 
 #
 # Miscellaneous filesystems
@@ -739,29 +802,52 @@
 #
 # Partition Types
 #
-CONFIG_PARTITION_ADVANCED=y
-# CONFIG_ACORN_PARTITION is not set
-# CONFIG_OSF_PARTITION is not set
-# CONFIG_AMIGA_PARTITION is not set
-# CONFIG_ATARI_PARTITION is not set
-# CONFIG_MAC_PARTITION is not set
+# CONFIG_PARTITION_ADVANCED is not set
 CONFIG_MSDOS_PARTITION=y
-# CONFIG_BSD_DISKLABEL is not set
-# CONFIG_MINIX_SUBPARTITION is not set
-# CONFIG_SOLARIS_X86_PARTITION is not set
-# CONFIG_UNIXWARE_DISKLABEL is not set
-# CONFIG_LDM_PARTITION is not set
-# CONFIG_SGI_PARTITION is not set
-# CONFIG_ULTRIX_PARTITION is not set
-# CONFIG_SUN_PARTITION is not set
-# CONFIG_KARMA_PARTITION is not set
-# CONFIG_EFI_PARTITION is not set
-# CONFIG_SYSV68_PARTITION is not set
 
 #
 # Native Language Support
 #
-# CONFIG_NLS is not set
+CONFIG_NLS=y
+CONFIG_NLS_DEFAULT="cp437"
+CONFIG_NLS_CODEPAGE_437=y
+# CONFIG_NLS_CODEPAGE_737 is not set
+# CONFIG_NLS_CODEPAGE_775 is not set
+# CONFIG_NLS_CODEPAGE_850 is not set
+# CONFIG_NLS_CODEPAGE_852 is not set
+# CONFIG_NLS_CODEPAGE_855 is not set
+# CONFIG_NLS_CODEPAGE_857 is not set
+# CONFIG_NLS_CODEPAGE_860 is not set
+# CONFIG_NLS_CODEPAGE_861 is not set
+# CONFIG_NLS_CODEPAGE_862 is not set
+# CONFIG_NLS_CODEPAGE_863 is not set
+# CONFIG_NLS_CODEPAGE_864 is not set
+# CONFIG_NLS_CODEPAGE_865 is not set
+# CONFIG_NLS_CODEPAGE_866 is not set
+# CONFIG_NLS_CODEPAGE_869 is not set
+# CONFIG_NLS_CODEPAGE_936 is not set
+# CONFIG_NLS_CODEPAGE_950 is not set
+# CONFIG_NLS_CODEPAGE_932 is not set
+# CONFIG_NLS_CODEPAGE_949 is not set
+# CONFIG_NLS_CODEPAGE_874 is not set
+# CONFIG_NLS_ISO8859_8 is not set
+# CONFIG_NLS_CODEPAGE_1250 is not set
+# CONFIG_NLS_CODEPAGE_1251 is not set
+CONFIG_NLS_ASCII=y
+# CONFIG_NLS_ISO8859_1 is not set
+# CONFIG_NLS_ISO8859_2 is not set
+# CONFIG_NLS_ISO8859_3 is not set
+# CONFIG_NLS_ISO8859_4 is not set
+# CONFIG_NLS_ISO8859_5 is not set
+# CONFIG_NLS_ISO8859_6 is not set
+# CONFIG_NLS_ISO8859_7 is not set
+# CONFIG_NLS_ISO8859_9 is not set
+# CONFIG_NLS_ISO8859_13 is not set
+# CONFIG_NLS_ISO8859_14 is not set
+# CONFIG_NLS_ISO8859_15 is not set
+# CONFIG_NLS_KOI8_R is not set
+# CONFIG_NLS_KOI8_U is not set
+# CONFIG_NLS_UTF8 is not set
 
 #
 # Instrumentation Support
@@ -773,9 +859,10 @@
 #
 CONFIG_TRACE_IRQFLAGS_SUPPORT=y
 # CONFIG_PRINTK_TIME is not set
-CONFIG_ENABLE_MUST_CHECK=y
+# CONFIG_ENABLE_MUST_CHECK is not set
 # CONFIG_MAGIC_SYSRQ is not set
 # CONFIG_UNUSED_SYMBOLS is not set
+# CONFIG_DEBUG_FS is not set
 # CONFIG_HEADERS_CHECK is not set
 # CONFIG_DEBUG_KERNEL is not set
 
@@ -783,6 +870,7 @@
 # Security options
 #
 # CONFIG_KEYS is not set
+# CONFIG_SECURITY is not set
 
 #
 # Cryptographic options
@@ -793,11 +881,12 @@
 # Library routines
 #
 CONFIG_BITREVERSE=y
-# CONFIG_CRC_CCITT is not set
-# CONFIG_CRC16 is not set
+CONFIG_CRC_CCITT=y
+CONFIG_CRC16=y
 # CONFIG_CRC_ITU_T is not set
 CONFIG_CRC32=y
-# CONFIG_LIBCRC32C is not set
+CONFIG_LIBCRC32C=y
+CONFIG_PLIST=y
 CONFIG_HAS_IOMEM=y
 CONFIG_HAS_IOPORT=y
 CONFIG_HAS_DMA=y
Index: packages/kernel/conf/defconfig-tiny-2.6.22
===================================================================
--- packages/kernel/conf/defconfig-tiny-2.6.22	(revision 144)
+++ packages/kernel/conf/defconfig-tiny-2.6.22	(working copy)
@@ -1,7 +1,7 @@
 #
 # Automatically generated make config: don't edit
 # Linux kernel version: 2.6.22.2
-# Tue Feb 12 16:19:45 2008
+# Wed Apr 23 14:20:28 2008
 #
 CONFIG_X86_32=y
 CONFIG_GENERIC_TIME=y
@@ -565,7 +565,7 @@
 # CONFIG_SATA_SVW is not set
 # CONFIG_ATA_PIIX is not set
 # CONFIG_SATA_MV is not set
-# CONFIG_SATA_NV is not set
+CONFIG_SATA_NV=y
 # CONFIG_PDC_ADMA is not set
 # CONFIG_SATA_QSTOR is not set
 # CONFIG_SATA_PROMISE is not set
@@ -1050,11 +1050,10 @@
 # Pseudo filesystems
 #
 CONFIG_PROC_FS=y
-CONFIG_PROC_KCORE=y
+# CONFIG_PROC_KCORE is not set
 CONFIG_PROC_SYSCTL=y
 CONFIG_SYSFS=y
-CONFIG_TMPFS=y
-# CONFIG_TMPFS_POSIX_ACL is not set
+# CONFIG_TMPFS is not set
 # CONFIG_HUGETLBFS is not set
 # CONFIG_HUGETLB_PAGE is not set
 CONFIG_RAMFS=y
@@ -1065,7 +1064,6 @@
 #
 # CONFIG_ADFS_FS is not set
 # CONFIG_AFFS_FS is not set
-# CONFIG_ECRYPT_FS is not set
 # CONFIG_HFS_FS is not set
 # CONFIG_HFSPLUS_FS is not set
 # CONFIG_BEFS_FS is not set
@@ -1175,52 +1173,9 @@
 #
 # Cryptographic options
 #
-CONFIG_CRYPTO=y
-CONFIG_CRYPTO_ALGAPI=y
-CONFIG_CRYPTO_BLKCIPHER=y
-CONFIG_CRYPTO_MANAGER=y
-# CONFIG_CRYPTO_HMAC is not set
-# CONFIG_CRYPTO_XCBC is not set
-# CONFIG_CRYPTO_NULL is not set
-# CONFIG_CRYPTO_MD4 is not set
-CONFIG_CRYPTO_MD5=y
-CONFIG_CRYPTO_SHA1=y
-CONFIG_CRYPTO_SHA256=y
-# CONFIG_CRYPTO_SHA512 is not set
-# CONFIG_CRYPTO_WP512 is not set
-# CONFIG_CRYPTO_TGR192 is not set
-# CONFIG_CRYPTO_GF128MUL is not set
-# CONFIG_CRYPTO_ECB is not set
-CONFIG_CRYPTO_CBC=y
-# CONFIG_CRYPTO_PCBC is not set
-# CONFIG_CRYPTO_LRW is not set
-# CONFIG_CRYPTO_CRYPTD is not set
-CONFIG_CRYPTO_DES=y
-# CONFIG_CRYPTO_FCRYPT is not set
-# CONFIG_CRYPTO_BLOWFISH is not set
-# CONFIG_CRYPTO_TWOFISH is not set
-# CONFIG_CRYPTO_TWOFISH_586 is not set
-# CONFIG_CRYPTO_SERPENT is not set
-# CONFIG_CRYPTO_AES is not set
-# CONFIG_CRYPTO_AES_586 is not set
-CONFIG_CRYPTO_CAST5=y
-# CONFIG_CRYPTO_CAST6 is not set
-# CONFIG_CRYPTO_TEA is not set
-# CONFIG_CRYPTO_ARC4 is not set
-# CONFIG_CRYPTO_KHAZAD is not set
-# CONFIG_CRYPTO_ANUBIS is not set
-# CONFIG_CRYPTO_DEFLATE is not set
-# CONFIG_CRYPTO_MICHAEL_MIC is not set
-# CONFIG_CRYPTO_CRC32C is not set
-# CONFIG_CRYPTO_CAMELLIA is not set
+# CONFIG_CRYPTO is not set
 
 #
-# Hardware crypto devices
-#
-# CONFIG_CRYPTO_DEV_PADLOCK is not set
-# CONFIG_CRYPTO_DEV_GEODE is not set
-
-#
 # Library routines
 #
 CONFIG_BITREVERSE=y
Index: packages/kernel/serengeti_cheetah-x86_64.mk
===================================================================
--- packages/kernel/serengeti_cheetah-x86_64.mk	(revision 153)
+++ packages/kernel/serengeti_cheetah-x86_64.mk	(working copy)
@@ -2,9 +2,9 @@
 
 KERNEL_URL=http://kernel.org/pub/linux/kernel/v2.6/
 KERNEL_SOURCE=linux-$(KERNEL_VERSION).tar.bz2
-KERNEL_CONFIG=$(PACKAGE_DIR)/kernel/conf/defconfig-serengeti_cheetah-x86_64
-KERNEL_SPEED_BUILD=-j 6
 
+# KERNEL_CONFIG is defined in the platform configuration
+
 TINY_URL=http://elinux.org/images/0/0e/
 TINY_SOURCE=Tiny-quilt-2.6.22.1-1.tar.gz
 TINY_DIR=$(KERNEL_DIR)/tiny/patches
Index: packages/kernel/tiny-2.6.22.mk
===================================================================
--- packages/kernel/tiny-2.6.22.mk	(revision 144)
+++ packages/kernel/tiny-2.6.22.mk	(working copy)
@@ -1,4 +1,4 @@
-# Build file for the Tyan S2891 LAB kernel
+# Build file for the a tiny 2.6.22 LAB kernel
 
 KERNEL_URL=http://kernel.org/pub/linux/kernel/v2.6/
 KERNEL_SOURCE=linux-$(KERNEL_VERSION).tar.bz2