Fix a quite a couple of warnings and potential errors in console code...

Signed-off-by: Stefan Reinauer <stepan@coresystems.de>

Index: src/pc80/serial.c
===================================================================
--- src/pc80/serial.c	(revision 3461)
+++ src/pc80/serial.c	(working copy)
@@ -91,8 +91,13 @@
 #endif
 	outb(UART_LCS, TTYS0_BASE + UART_LCR);
 }
+
 #else
+/* CONFIG_USE_PRINTK_IN_CAR == 1 */
+#if CONFIG_USE_INIT == 0
 #include "../lib/uart8250.c"
+#endif
+
 extern void uart8250_init(unsigned base_port, unsigned divisor, unsigned lcs);
 static void uart_init(void)
 {
Index: src/arch/i386/lib/console.c
===================================================================
--- src/arch/i386/lib/console.c	(revision 3461)
+++ src/arch/i386/lib/console.c	(working copy)
@@ -13,9 +13,11 @@
 
 #include "console_printk.c"
 
+#if CONFIG_USE_INIT == 0
 // do_printk
 #include "../../../console/vtxprintf.c"
 #include "printk_init.c"
+#endif
 
 #endif /* CONFIG_USE_PRINTK_IN_CAR */
 
@@ -23,7 +25,6 @@
 #define COREBOOT_EXTRA_VERSION ""
 #endif
 
-
 static void console_init(void)
 {
 	static const char console_test[] = 
Index: src/arch/i386/lib/console_print.c
===================================================================
--- src/arch/i386/lib/console_print.c	(revision 3461)
+++ src/arch/i386/lib/console_print.c	(working copy)
@@ -58,58 +58,59 @@
 	}
 }
 
-#define NOINLINE __attribute__((noinline))
-static void print_emerg_char(unsigned char byte) { __console_tx_char(BIOS_EMERG, byte); }
-static void print_emerg_hex8(unsigned char value){ __console_tx_hex8(BIOS_EMERG, value); }
-static void print_emerg_hex16(unsigned short value){ __console_tx_hex16(BIOS_EMERG, value); }
-static void print_emerg_hex32(unsigned int value) { __console_tx_hex32(BIOS_EMERG, value); }
-static void print_emerg(const char *str) { __console_tx_string(BIOS_EMERG, str); }
+#define STATIC 
 
-static void print_alert_char(unsigned char byte) { __console_tx_char(BIOS_ALERT, byte); }
-static void print_alert_hex8(unsigned char value) { __console_tx_hex8(BIOS_ALERT, value); }
-static void print_alert_hex16(unsigned short value){ __console_tx_hex16(BIOS_ALERT, value); }
-static void print_alert_hex32(unsigned int value) { __console_tx_hex32(BIOS_ALERT, value); }
-static void print_alert(const char *str) { __console_tx_string(BIOS_ALERT, str); }
+STATIC void print_emerg_char(unsigned char byte) { __console_tx_char(BIOS_EMERG, byte); }
+STATIC void print_emerg_hex8(unsigned char value){ __console_tx_hex8(BIOS_EMERG, value); }
+STATIC void print_emerg_hex16(unsigned short value){ __console_tx_hex16(BIOS_EMERG, value); }
+STATIC void print_emerg_hex32(unsigned int value) { __console_tx_hex32(BIOS_EMERG, value); }
+STATIC void print_emerg(const char *str) { __console_tx_string(BIOS_EMERG, str); }
 
-static void print_crit_char(unsigned char byte) { __console_tx_char(BIOS_CRIT, byte); }
-static void print_crit_hex8(unsigned char value) { __console_tx_hex8(BIOS_CRIT, value); }
-static void print_crit_hex16(unsigned short value){ __console_tx_hex16(BIOS_CRIT, value); }
-static void print_crit_hex32(unsigned int value) { __console_tx_hex32(BIOS_CRIT, value); }
-static void print_crit(const char *str) { __console_tx_string(BIOS_CRIT, str); }
+STATIC void print_alert_char(unsigned char byte) { __console_tx_char(BIOS_ALERT, byte); }
+STATIC void print_alert_hex8(unsigned char value) { __console_tx_hex8(BIOS_ALERT, value); }
+STATIC void print_alert_hex16(unsigned short value){ __console_tx_hex16(BIOS_ALERT, value); }
+STATIC void print_alert_hex32(unsigned int value) { __console_tx_hex32(BIOS_ALERT, value); }
+STATIC void print_alert(const char *str) { __console_tx_string(BIOS_ALERT, str); }
 
-static void print_err_char(unsigned char byte) { __console_tx_char(BIOS_ERR, byte); }
-static void print_err_hex8(unsigned char value) { __console_tx_hex8(BIOS_ERR, value); }
-static void print_err_hex16(unsigned short value){ __console_tx_hex16(BIOS_ERR, value); }
-static void print_err_hex32(unsigned int value) { __console_tx_hex32(BIOS_ERR, value); }
-static void print_err(const char *str) { __console_tx_string(BIOS_ERR, str); }
+STATIC void print_crit_char(unsigned char byte) { __console_tx_char(BIOS_CRIT, byte); }
+STATIC void print_crit_hex8(unsigned char value) { __console_tx_hex8(BIOS_CRIT, value); }
+STATIC void print_crit_hex16(unsigned short value){ __console_tx_hex16(BIOS_CRIT, value); }
+STATIC void print_crit_hex32(unsigned int value) { __console_tx_hex32(BIOS_CRIT, value); }
+STATIC void print_crit(const char *str) { __console_tx_string(BIOS_CRIT, str); }
 
-static void print_warning_char(unsigned char byte) { __console_tx_char(BIOS_WARNING, byte); }
-static void print_warning_hex8(unsigned char value) { __console_tx_hex8(BIOS_WARNING, value); }
-static void print_warning_hex16(unsigned short value){ __console_tx_hex16(BIOS_WARNING, value); }
-static void print_warning_hex32(unsigned int value) { __console_tx_hex32(BIOS_WARNING, value); }
-static void print_warning(const char *str) { __console_tx_string(BIOS_WARNING, str); }
+STATIC void print_err_char(unsigned char byte) { __console_tx_char(BIOS_ERR, byte); }
+STATIC void print_err_hex8(unsigned char value) { __console_tx_hex8(BIOS_ERR, value); }
+STATIC void print_err_hex16(unsigned short value){ __console_tx_hex16(BIOS_ERR, value); }
+STATIC void print_err_hex32(unsigned int value) { __console_tx_hex32(BIOS_ERR, value); }
+STATIC void print_err(const char *str) { __console_tx_string(BIOS_ERR, str); }
 
-static void print_notice_char(unsigned char byte) { __console_tx_char(BIOS_NOTICE, byte); }
-static void print_notice_hex8(unsigned char value) { __console_tx_hex8(BIOS_NOTICE, value); }
-static void print_notice_hex16(unsigned short value){ __console_tx_hex16(BIOS_NOTICE, value); }
-static void print_notice_hex32(unsigned int value) { __console_tx_hex32(BIOS_NOTICE, value); }
-static void print_notice(const char *str) { __console_tx_string(BIOS_NOTICE, str); }
+STATIC void print_warning_char(unsigned char byte) { __console_tx_char(BIOS_WARNING, byte); }
+STATIC void print_warning_hex8(unsigned char value) { __console_tx_hex8(BIOS_WARNING, value); }
+STATIC void print_warning_hex16(unsigned short value){ __console_tx_hex16(BIOS_WARNING, value); }
+STATIC void print_warning_hex32(unsigned int value) { __console_tx_hex32(BIOS_WARNING, value); }
+STATIC void print_warning(const char *str) { __console_tx_string(BIOS_WARNING, str); }
 
-static void print_info_char(unsigned char byte) { __console_tx_char(BIOS_INFO, byte); }
-static void print_info_hex8(unsigned char value) { __console_tx_hex8(BIOS_INFO, value); }
-static void print_info_hex16(unsigned short value){ __console_tx_hex16(BIOS_INFO, value); }
-static void print_info_hex32(unsigned int value) { __console_tx_hex32(BIOS_INFO, value); }
-static void print_info(const char *str) { __console_tx_string(BIOS_INFO, str); }
+STATIC void print_notice_char(unsigned char byte) { __console_tx_char(BIOS_NOTICE, byte); }
+STATIC void print_notice_hex8(unsigned char value) { __console_tx_hex8(BIOS_NOTICE, value); }
+STATIC void print_notice_hex16(unsigned short value){ __console_tx_hex16(BIOS_NOTICE, value); }
+STATIC void print_notice_hex32(unsigned int value) { __console_tx_hex32(BIOS_NOTICE, value); }
+STATIC void print_notice(const char *str) { __console_tx_string(BIOS_NOTICE, str); }
 
-static void print_debug_char(unsigned char byte) { __console_tx_char(BIOS_DEBUG, byte); }
-static void print_debug_hex8(unsigned char value) { __console_tx_hex8(BIOS_DEBUG, value); }
-static void print_debug_hex16(unsigned short value){ __console_tx_hex16(BIOS_DEBUG, value); }
-static void print_debug_hex32(unsigned int value) { __console_tx_hex32(BIOS_DEBUG, value); }
-static void print_debug(const char *str) { __console_tx_string(BIOS_DEBUG, str); }
+STATIC void print_info_char(unsigned char byte) { __console_tx_char(BIOS_INFO, byte); }
+STATIC void print_info_hex8(unsigned char value) { __console_tx_hex8(BIOS_INFO, value); }
+STATIC void print_info_hex16(unsigned short value){ __console_tx_hex16(BIOS_INFO, value); }
+STATIC void print_info_hex32(unsigned int value) { __console_tx_hex32(BIOS_INFO, value); }
+STATIC void print_info(const char *str) { __console_tx_string(BIOS_INFO, str); }
 
-static void print_spew_char(unsigned char byte) { __console_tx_char(BIOS_SPEW, byte); }
-static void print_spew_hex8(unsigned char value) { __console_tx_hex8(BIOS_SPEW, value); }
-static void print_spew_hex16(unsigned short value){ __console_tx_hex16(BIOS_SPEW, value); }
-static void print_spew_hex32(unsigned int value) { __console_tx_hex32(BIOS_SPEW, value); }
-static void print_spew(const char *str) { __console_tx_string(BIOS_SPEW, str); }
+STATIC void print_debug_char(unsigned char byte) { __console_tx_char(BIOS_DEBUG, byte); }
+STATIC void print_debug_hex8(unsigned char value) { __console_tx_hex8(BIOS_DEBUG, value); }
+STATIC void print_debug_hex16(unsigned short value){ __console_tx_hex16(BIOS_DEBUG, value); }
+STATIC void print_debug_hex32(unsigned int value) { __console_tx_hex32(BIOS_DEBUG, value); }
+STATIC void print_debug(const char *str) { __console_tx_string(BIOS_DEBUG, str); }
 
+STATIC void print_spew_char(unsigned char byte) { __console_tx_char(BIOS_SPEW, byte); }
+STATIC void print_spew_hex8(unsigned char value) { __console_tx_hex8(BIOS_SPEW, value); }
+STATIC void print_spew_hex16(unsigned short value){ __console_tx_hex16(BIOS_SPEW, value); }
+STATIC void print_spew_hex32(unsigned int value) { __console_tx_hex32(BIOS_SPEW, value); }
+STATIC void print_spew(const char *str) { __console_tx_string(BIOS_SPEW, str); }
+